// opal -- online learning with kernel slicing
//  $Id: opal_conf.h 749 2011-12-24 16:18:20Z ynaga $
// Copyright (c) 2009-2011 Naoki Yoshinaga <ynaga@tkl.iis.u-tokyo.ac.jp>
#ifndef OPAL_CONFIG_H
#define OPAL_CONFIG_H
// configure options for opal

// use TR1 unordered_map / unordered_set for map / set type
// to slightly speeding up the training
#ifndef USE_HASH
#define USE_HASH
#endif

// build a multi-class classifier instead of a binary classifier
// #define USE_MULTICLASS
#define MAX_NUM_CLASSES  1024

// use TR1 mt19937 for shuffling examples instead of XorShift
// set to perform proper shuffling (not bottleneck, though)
// #define USE_MT

// use map or TR1 unordered_map to implement weight trie and partial margin trie
// set to improve the portablilty of pa.h (independent of cedar.h)
// #define USE_HASH_TRIE // 1.5-2 times slower
// #define USE_MAP_TRIE  // even more slower
#ifdef USE_HASH_TRIE
#ifndef USE_HASH
#define USE_HASH
#endif
#endif

// use RDTSC to compute timings
// set to report training and test time (overhead is negligible)
// unset to improve portability of pa.h
#ifndef USE_TIMER
#define USE_TIMER
#endif

#endif /* OPAL_CONFIG_H */
